/*	$Id: ai_msg.c,v 1.15 2001/06/02 22:18:57 riq Exp $	*/
/* Tenes Empanadas Graciela
 *
 * Copyright (C) 2000 Ricardo Quesada
 *
 * Author: Ricardo Calixto Quesada <rquesada@core-sdi.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * @file ai_msg.c
 * Mensaje que puede decir el robot ;)
 */

#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "client.h"
#include "ai_msg.h"


aimsg_t mensajes_hi[] = {
	{ N_("Hi %s"), 1},
	{ N_("Good luck %s"), 1},
	{ N_("How are you %s ?"), 1},
	{ N_("Welcome back %s!"), 1},
	{ N_("%s, I'll be the winner"), 1},
	{ N_("Hey %s!"), 1},
	{ "Ciao %s", 1},
	{ "Hola %s", 1},
};
#define NR_MSGS_HI ( sizeof(mensajes_hi) / sizeof(mensajes_hi[0]))

aimsg_t mensajes_bye[] = {
	{ N_("Goodbye %s"), 1},
	{ N_("%s, You really dont know how to play!"), 1 },
	{ N_("%s Better luck for the next time"), 1 },
	{ N_("%s, try to improve your game"), 1 },
};
#define NR_MSGS_BYE ( sizeof(mensajes_bye) / sizeof(mensajes_bye[0]))

aimsg_t mensajes_misc[] = {
	{ N_("%s, Do you have a sister ?"), 1},
	{ N_("I love this game"), 0 },
	{ N_("%s, I cant believe it!"), 1 },
	{ N_("%s, Do you have Lewinsky's phone ?"), 1 },
	{ N_("Does anyone speak Speranto ?"), 0},
	{ N_("%s, You play very well"), 0},
	{ N_("Thanks"), 0 },
	{ N_("mmm..."), 0 },
	{ N_("%s, Are you a robot ?"), 1 },
	{ N_("Geronimoooooo"), 0 },
	{ N_("I'm a bit tired"), 0 },
	{ N_("I'm hungry"), 0 },
	{ N_("Who wants an Empanada ?"), 0 },
	/* frases que no deben ser traducidas */
	{ "Empanadas sin dientes, para las viejas sin dientes", 0 },
	{ "Se me escapo la tortuga", 0 },
	{ "%s parla tedesco", 1 },
	{ "Alguien ha visto a mi gata?", 0 },
};
#define NR_MSGS_MISC ( sizeof(mensajes_misc) / sizeof(mensajes_misc[0]))


static char *nombres[] = {
	N_("Coca Sarli"),
	N_("Ciccolina"),
	N_("Raton Perez"),
	N_("Geniol"),
	N_("Fantoche"),
	N_("Jirafa"),
	N_("Guaymayen"),
	N_("Mono Mario"),
	N_("Havanna"),
	N_("Shakira"),
	N_("Talia"),
	N_("Spice Girls"),
	N_("Pitufina"),
	N_("Topacio"),
	N_("Batman"),
	N_("Gatubela"),
	N_("La cuca"),
	N_("Bush"),
	N_("Lewinsky"),
	N_("Clinton"),
	N_("Chupete"),
	N_("Gaturro"),
	N_("Mr.President"),
	N_("Batistuta"),
	N_("Perla"),
	N_("Maradona"),
	N_("Pele"),
	N_("Comanche"),
	N_("Tehuelche"),
	N_("Pampa"),
};
#define NR_NAMES ( sizeof(nombres) / sizeof(nombres[0]))


TEG_STATUS ai_out_mensaje( int r, char *format, ...)
{
        va_list args;
	char buf[PROT_MAX_LEN];
	int i = RANDOM_MAX(0,r-1);

	if( i > 3 )
		return TEG_STATUS_ERROR;

	va_start(args, format);
	vsprintf(buf, format, args);
	va_end(args);

	return out_mensaje( buf );
}

TEG_STATUS ai_msg(int type, char *name )
{
	int i;
	char nombre[PLAYERNAME_MAX_LEN];

	if( name ) {
		strncpy( nombre, name, sizeof(nombre)-1);
		nombre[sizeof(nombre)-1]=0;
	} else {
		i = RANDOM_MAX(0, NR_NAMES-1);
		strncpy( nombre, _(nombres[i]), sizeof(nombre)-1);
		nombre[sizeof(nombre)-1]=0;
	}

	switch( type ) {
	case AI_MSG_MISC:
		i = RANDOM_MAX(0,NR_MSGS_MISC-1);
		ai_out_mensaje( 250, _(mensajes_misc[i].msg), nombre );
		break;
	case AI_MSG_HI:
		i = RANDOM_MAX(0,NR_MSGS_HI-1);
		ai_out_mensaje( 6, _(mensajes_hi[i].msg), nombre );
		break;
	case AI_MSG_BYE:
		i = RANDOM_MAX(0,NR_MSGS_BYE-1);
		ai_out_mensaje( 50, _(mensajes_bye[i].msg), nombre );
		break;
	}
	return TEG_STATUS_SUCCESS;
}

char * ai_nombre()
{
	int i = RANDOM_MAX(0,NR_NAMES-1);
	return _(nombres[i]);
}
