/*	$Id: jugador.h,v 1.32 2001/05/28 03:33:04 riq Exp $	*/
/* Tenes Empanadas Graciela
 *
 * Copyright (C) 2000 Ricardo Quesada
 *
 * Author: Ricardo Calixto Quesada <rquesada@core-sdi.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * @file jugador.h
 */
#ifndef __TEGS_JUGADOR_H
#define __TEGS_JUGADOR_H

#include "server.h"


typedef struct _jugador {
	LIST_ENTRY next;
	int numjug;				/**< numero de jugador: 0,1,2... */
	char nombre[PLAYERNAME_MAX_LEN];	/**< nombre */
	char addr[PLAYERADDR_MAX_LEN];		/**< internet address */
	int color;				/**< ejercito o color */
	LIST_ENTRY paises;			/**< paises que tiene */
	LIST_ENTRY pactos;			/**< pactos que hizo */
	LIST_ENTRY tarjetas;			/**< FIXME NOT USED: tarjetas sacadas */
	int objetivo;				/**< que objetivo tiene asignado */
	BOOLEAN hizo_canje;			/**< para ver si hizo algun canje */
	BOOLEAN jugador;			/**< observer o jugador.
						   Si es observer es un tipo que se conecta
						   para ver como va el juego, enviar mensajes
						   etc, pero no puede jugar */
	int turno_conq;				/**< Conquistados en el turno
						   Es para cuando quiere pedir tarjeta.
						   Tiene que conq 1 hasta el 3 canje
						   luego 2 */
	int tot_paises;				/**< total de paises. (optimizacion) */
	int tot_ejercitos;			/**< total de ejercitos (") */
	int tot_tarjetas;			/**< total de tarjetas (") */
	int tot_canjes;				/**< total de canjes que hizo */
	int fd;					/**< file descriptor */
	int estado;				/**< que es lo que tiene que hacer: mover,
						   descon, reagrup, etc */
	int pais_src;				/**< en caso de conquistar un pais, esta 2 varibles */
	int pais_dst;				/**< indican de donde a donde (usadas en TOKEN_TROPAS) */
} JUGADOR, *PJUGADOR;

typedef TEG_STATUS (*jug_map_func)( PJUGADOR pJ);

/*
 * funciones y variables exportadas
 */
extern LIST_ENTRY g_list_jugador;

TEG_STATUS jugador_initplayer( PJUGADOR j );
void jugador_init( void );
PJUGADOR jugador_ins( PJUGADOR j, BOOLEAN esjugador );
#define jugador_ins_player(a) jugador_ins(a,TRUE)
#define jugador_ins_ro(a) jugador_ins(a,FALSE)
TEG_STATUS jugador_del_hard(PJUGADOR j);
TEG_STATUS jugador_del_soft( PJUGADOR pJ );
TEG_STATUS jugador_flush();
TEG_STATUS jugador_asignarpais( int numjug, PPAIS p);
TEG_STATUS jugador_whois( int numjug, PJUGADOR *j);
TEG_STATUS jugador_whoisfd( int fd, PJUGADOR *j);
BOOLEAN jugador_esta_xxx( int fd, int condicion, int strict );
BOOLEAN jugador_esta_xxx_plus( int fd, int condicion, int strict, PJUGADOR *j );
TEG_STATUS jugador_listar_paises( PJUGADOR pJ, int *paises );
TEG_STATUS jugador_listar_conts( PJUGADOR pJ, unsigned long *ret );
TEG_STATUS jugador_clear_turn( PJUGADOR j );
int jugador_fichasc_cant( PJUGADOR pJ );
TEG_STATUS jugador_all_set_status( JUG_ESTADO );
TEG_STATUS jugador_chequear_perdio( PJUGADOR pJ );
TEG_STATUS jugador_poner_perdio( PJUGADOR pJ );
TEG_STATUS jugador_numjug_libre( int *libre);
TEG_STATUS jugador_from_indice( int j, int *real_j );
TEG_STATUS jugador_map( jug_map_func func );

#define JUGADOR_CONNECTED(a) jugador_esta_xxx(a,JUG_ESTADO_CONNECTED,0)
#define JUGADOR_HABILITADO(a) jugador_esta_xxx(a,JUG_ESTADO_HABILITADO,0)
#define JUGADOR_HABILITADO_P(a,j) jugador_esta_xxx_plus(a,JUG_ESTADO_HABILITADO,0,j)
#define JUGADOR_FICHAS(a) jugador_esta_xxx(a,JUG_ESTADO_FICHAS,1)
#define JUGADOR_FICHAS2(a) jugador_esta_xxx(a,JUG_ESTADO_FICHAS2,1)
#define JUGADOR_ATAQUE(a) jugador_esta_xxx(a,JUG_ESTADO_ATAQUE,1)
#define JUGADOR_ATAQUE_P(a,j) jugador_esta_xxx_plus(a,JUG_ESTADO_ATAQUE,1,j)
#define JUGADOR_TROPAS(a) jugador_esta_xxx(a,JUG_ESTADO_TROPAS,1)
#define JUGADOR_TROPAS_P(a,j) jugador_esta_xxx_plus(a,JUG_ESTADO_TROPAS,1,j)

#endif /* __TEGS_JUGADOR_H */
